该类定义了用户自定义结构截面的属性和方法。
继承自:Autodesk.Revit.DB.Structure.StructuralSection
.
用户定义的结构截面可以通过以下方式创建:
public StructuralSectionUserDefined(string name, string description, StructuralMaterialType materialType, IList<SectionProperty> sectionProperties, double area, double perimeter);
Name
:用户定义结构截面的名称。Description
:用户定义结构截面的描述信息。MaterialType
:结构截面的材料类型(钢,混凝土,木材等)。SectionProperties
:截面的属性列表(包括截面形状、惯性矩、面积等)。Area
:用户定义结构截面的面积。Perimeter
:用户定义结构截面的周长。IsValid
:检查用户定义的结构截面是否有效。如果截面的属性不满足某些限制,则该方法将返回false。CanExtend
:检查用户定义的结构截面是否可以扩展。如果截面不能扩展,则该方法将返回false。Extend
:扩展用户定义的结构截面。该方法将截面的属性按比例扩展。以下示例演示了如何创建并使用用户定义的结构截面:
//定义截面属性
SectionProperty s1 = new SectionProperty("Width", SectionPropertyType.Width, 7.8);
SectionProperty s2 = new SectionProperty("Height", SectionPropertyType.Height, 10.2);
SectionProperty s3 = new SectionProperty("Area", SectionPropertyType.Area, 79.56);
SectionProperty s4 = new SectionProperty("Ix", SectionPropertyType.Ix, 2525.36);
SectionProperty s5 = new SectionProperty("Iy", SectionPropertyType.Iy, 865.44);
List<SectionProperty> properties = new List<SectionProperty>{ s1, s2, s3, s4, s5 };
//创建截面
var mySection = new StructuralSectionUserDefined("My Section", "A user defined section", StructuralMaterialType.Steel, properties, 79.56, 36.0);
//使用截面
var wallType = new WallType("My Wall", mySection, 0.2, 0.4);
Autodesk.Revit.Exceptions.ArgumentException
:如果用户定义的结构截面参数不合法,则抛出此异常。Autodesk.Revit.Exceptions.ArgumentNullException
:如果用户定义的结构截面参数为空,则抛出此异常。Autodesk.Revit.Exceptions.InvalidOperationException
:如果用户定义的结构截面无效,则抛出此异常。